#define BUF_SIZE 80
static bank2 char buf [BUF_SIZE];
static volatile byte read_ptr;
static volatile byte write_ptr;

void initBuf(void) {
  read_ptr = 0;
  write_ptr = 1;
}

// return 0 if buffer has been overflown;
// return 1 if ok;
byte putBuf(char c) {
  if (write_ptr == read_ptr) {
    return 0;
  }
  buf[write_ptr] = c;
  write_ptr++;
  if (write_ptr == BUF_SIZE)
    write_ptr = 0;
  return 1;
}

// return 0 if buffer is empty;
// return 1 if buffer contains chars;
byte checkBuf(void) {
  char next_read_ptr = read_ptr+1;
  if (next_read_ptr == BUF_SIZE)
    next_read_ptr = 0;
  if (next_read_ptr == write_ptr)
    return 0;
  return 1;
}

// return 0 if buffer is empty;
// return character if ok;
byte scanBuf(void) {
  char next_read_ptr = read_ptr+1;
  if (next_read_ptr == BUF_SIZE)
    next_read_ptr = 0;
  if (next_read_ptr == write_ptr)
    return 0;
  read_ptr = next_read_ptr;
  return buf[read_ptr];
}

byte getBuf(void) {
  char c; 
  byte i = 0;
  CLRWDT();
  while ((c = scanBuf()) == 0) {
    CLRWDT();
    i++;
    if ( i == 255 )
      return 0;
  }
  return c;
}
